var dgram = require('dgram');
var Buffer = require('buffer').Buffer;

function ArtNetClient(host, port, univ) {
	this._host = host;
	this._port = port;
	this._socket = dgram.createSocket("udp4");
	this.HEADER = [65, 114, 116, 45, 78, 101, 116, 0, 0, 80, 0, 14]; // 0 - 11
	this.SEQUENCE = [255]; // 12
	this.PHYSICAL = [0]; // 13
	this.UNIVERSE = [univ, 255]; // 14 - 15
	//this.LENGTH = [0, 13]; // 16 - 17
}
exports.ArtNetClient = ArtNetClient;

exports.createClient = function(host, port, univ) {
	return new ArtNetClient(host, port, univ);
}

ArtNetClient.prototype.send = function(data) {
	// Calcualte the length
	var length = 100;
	var length_upper = Math.floor(length / 256);
	var length_lower = length % 256;
	
	var data = this.HEADER.concat(this.SEQUENCE).concat(this.PHYSICAL).concat(this.UNIVERSE).concat([length_upper, length_lower]).concat(data);
	var buf = Buffer(data);
	var self = this._socket;
	this._socket.send(buf, 0, 530, this._port, this._host, function() {
		self.close();
	});
}

ArtNetClient.prototype.close = function(){
	this._socket.close();
};