var dgram = require('dgram');
var Buffer = require('buffer').Buffer;

function ArtNetClient_brd(host, port) {
	this._host = host;
	this._port = port;
	this._socket = dgram.createSocket("udp4");
	this.HEADER = [65, 114, 116, 45, 78, 101, 116, 0, 80, 32, 0, 14]; // 0 - 11
	this.AUX1 = [0]; // 12
	this.AUX2 = [0]; // 13
}
exports.ArtNetClient_brd = ArtNetClient_brd;

exports.createClient = function(host, port) {
	return new ArtNetClient_brd(host, port);
}

ArtNetClient_brd.prototype.send = function() {

	var data = this.HEADER.concat(this.AUX1).concat(this.AUX2);
	var buf = Buffer(data);
	var self = this._socket;
	//console.log("ART POOL IP : "+this._host);
	this._socket.send(buf, 0, buf.length, this._port, this._host, function() {
		console.log("send BRD ART POOL");
		self.close();
	});
	
}

ArtNetClient_brd.prototype.close = function(){
	this._socket.close();
};