var util = require('util');
var EventEmitter = require('events');
var dgram = require('dgram');

function bin2String(msg, start, stop) {
  var result = "";
  for (var i = start; i < stop; i++) {
    result += String.fromCharCode(msg.readUInt8(i,true));
  }
  return result;
}

// ArtNet server class
function listen(addr, port, cb, cb_pool) {
	this.port = port;
	EventEmitter.call(this);
	
	// Set up the socket
	var sock = dgram.createSocket({type: 'udp4', reuseAddr: true}, function (msg, peer) {
		
		if ((msg.readUInt8(9,true) == 33) && (msg.readUInt8(8,true) == 0)) { //check opcode artnet pollreply
			if (bin2String(msg, 26, 41) == "HGLight PixTube") {
				cb_pool(peer);
				//console.log("PixTube POOL REPLY", peer.address);
			}
		} else if ((msg.readUInt8(9,true) == 80) && (msg.readUInt8(8,true) == 0)) { //check opcode artnet packet
			var sequence = msg.readUInt8(12,true);	
			var physical = msg.readUInt8(13,true);
			var universe = msg.readUInt8(14,true);
			var offset = msg.readUInt8(16,true);
			//var length = msg.readUInt8(17,true);
			var length = 100;
			
			var rawData = [];
		
			for( i = 18; i < 18 + length; i++ ){
				rawData.push( msg.readUInt8(i) );
			}
			
			var retData = {sequence: sequence, physical: physical, universe: universe, length: length, data: rawData};
			
			cb(retData, peer);
		}
	});
	//console.log(sock);
	sock.bind(port, addr);
}

// Setup EventEmitter for the ArtNetServer
util.inherits(listen, EventEmitter);

exports.listen = listen