const http = require('http');
const electron = require('electron');
const {app, BrowserWindow} = require('electron');
const url = require('url');
const {ipcMain} = require('electron');
var path = require('path');
var os = require('os');
const fs = require('fs');
var Netmask = require('netmask').Netmask;
var artnetclient = require('./lib/artnet_client.js');
var artnetclient_brd = require('./lib/artnet_client_brd.js');
var artnetsrv = require('./lib/artnet_server.js');

var win = null;
var win2 = null;


function createWindow() {

   win = new BrowserWindow({
    	fullscreen:false,
    	title: "PixelCtr - HGLight",
    	frame:true,
    	backgroundColor : "#000000",
    	icon: path.join(__dirname, 'assets/icons/png/64x64.png')
    });
	//win.setMenu(null);
	
    win.loadURL(url.format({
      pathname: path.join(__dirname+"/local", 'index.html'),
      protocol: 'file:',
      slashes: true
    }));
    
    //win.minimize();
    
	
  
    // Ouvre le DevTools.
    //win.webContents.openDevTools()
    // Émit lorsque la fenêtre est fermée.
    win.on('closed', () => {
      win = null;
    });
    
}


app.on('ready', function() {
	createWindow();
});
  
app.on('window-all-closed', () => {
	if (process.platform !== 'darwin') {
		app.quit()
	}
})
  
app.on('activate', () => {
	if (win === null) {
		createWindows();
	}
});

var global_attente_device = false;
var global_timeout_search;

ipcMain.on("select_device", (event, ip) => {
	console.log("try device : ", ip);
	var router_send = artnetclient.createClient(ip, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 10;
	router_send.send(packet);
	global_attente_device = ip;
	global_timeout_search = setTimeout(function () {
		win.webContents.send('no_device');
	}, 5000);
});

ipcMain.on("modif_ip", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 20;
	packet[12] = value.ip0;
	packet[13] = value.ip1;
	packet[14] = value.ip2;
	packet[15] = value.ip3;
	router_send.send(packet);
});

ipcMain.on("modif_ip", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 20;
	packet[12] = value.ip0;
	packet[13] = value.ip1;
	packet[14] = value.ip2;
	packet[15] = value.ip3;
	router_send.send(packet);
});

ipcMain.on("modif_first_univ", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 30;
	packet[22] = value.first_univ;
	router_send.send(packet);
});

ipcMain.on("modif_nbr_strips", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 40;
	packet[23] = value.nbr_strips;
	router_send.send(packet);
});

ipcMain.on("modif_nbr_leds", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 50;
	packet[24] = value.nbr_leds;
	router_send.send(packet);
});

ipcMain.on("modif_type_leds", (event, value) => {
	var router_send = artnetclient.createClient(value.device, 6454, 65535);
	var packet = new Array(200);
	packet[100] = 60;
	packet[25] = value.type_leds;
	router_send.send(packet);
});

/*function send_art_poll_pixtube() {
	if (global_pixtube_interface != null) {
		var client = artnetclient_brd.createClient(global_pixtube_interface[2], 6454);
		client._socket.on('listening', function(){
	    	client._socket.setBroadcast(true);
		});
		client.send();
		//clean array for disconnect pixtube ?
		setTimeout(function () {
			global_know_pixtube.forEach(function(pixtube) {
				if (!temp_know_pixtube.includes(pixtube)) {
					console.log(pixtube + " disconnect");
					global_know_pixtube.splice(global_know_pixtube.indexOf(pixtube), 1);
					win.webContents.send('disconnect_pixtube', pixtube);
				}
			});
			console.log("global_know_pixtube : ", global_know_pixtube);
			temp_know_pixtube = [];
		}, 5000);
	}
}*/

//artnet servers receive
	artnetsrv.listen("0.0.0.0", 6454, function(msg, peer) {
		if (global_attente_device != false) {
			if (peer.address == global_attente_device) {
				global_attente_device = false;
				clearTimeout(global_timeout_search);
				console.log("reponse du device");
				win.webContents.send('device_online', msg.data);
			}
		}
	}, function (peer) {
		console.log("artpol reply receive");
	});